import 'package:flutter/cupertino.dart';
import 'package:osam/src/persist/persist_repository.dart';

abstract class Persist<ST, US> {
  factory Persist({@required String appName}) => PersistRepository<ST, US>(appName: appName);

  Future<void> init();

  Future<void> save({ST state, US uiState, int version});

  ST get getState;

  US get getUiState;

  int get version;

  Future<void> delete();

  bool get isPersistEnabled;
}
